	org $4000

	orcc #$50	; disable interrupts


	ldx #$400			; fill the screen with something
	ldd #$aaaa			; predictable so we can see
clp	std ,x++			; what's happening
	cmpx #$400+$1e00	;
	blo clp				;

	
	sta $ffc0	; set SAM memory mode
	sta $ffc3	; for PMODE3/4
	sta $ffc5	;
 
vs_loop
	sync		; wait for vsync
	lda $ff02	; clear vsync irq flag

	lda #$e0	; PMODE3
	sta $ff22	;

	lda $ff01	; enable hsync irq
	ora #1		;
	sta $ff01	;
 
	ldb #200	; number of hsync pulses to count

hs_loop
	lda $ff00	; clear hsync irq flag
	sync		; wait for hsync
	decb		;
	bne hs_loop	; keep going until count is reached

	; we come out of the loop a bit late to change mode before
	; the scanline starts, so wait another hsync and then
	; quickly change the mode.

	ldb #$f0	; PMODE4
	lda $ff00	; clear hsync irq flag
	sync		; wait for hsync
	stb $ff22	; set mode
 
	lda $ff01	; disable hsync irq
	anda #$fe	;
	sta $ff01	;
	
	bra vs_loop
